﻿using XF.Domain.Dependency;
using XF.Domain.Exceptions;

namespace Hotline.Settings.TimeLimits
{
    public class TimeLimitDomainService : ITimeLimitDomainService, IScopeDependency
    {
        private readonly ITimeLimitRepository _timeLimitRepository;

        public TimeLimitDomainService(ITimeLimitRepository timeLimitRepository)
        {
            _timeLimitRepository = timeLimitRepository;
        }

        public async Task<string> AddAsync(TimeLimit model, CancellationToken cancellationToken)
        {
            return await _timeLimitRepository.AddAsync(model, cancellationToken);
        }

        public async Task UpdateAsync(TimeLimit model, CancellationToken cancellationToken)
        {
            var dbModel = await _timeLimitRepository.GetAsync(model.Id, cancellationToken);
            if (dbModel == null)
            {
                throw new UserFriendlyException("无效数据");
            }
            await _timeLimitRepository.UpdateAsync(model, cancellationToken);
        }


        //public async Task Get(string WorkflowCode, DateTime BeginTime, Dictionary<string, string> param)
        //{
        //    //1>> 取出对应已启用的配置
        //    var model = await _timeLimitRepository.GetAsync(x => x.WorkflowCode == WorkflowCode && x.TimeLimitState == Share.Enums.Settings.ETimeLimitState.Enable);
        //    if (model != null)
        //    {
        //        //组合逻辑
        //        if (model.Combination.Count > 0)
        //        {
        //            foreach (var item in model.Combination)
        //            {
        //                item.CombinationParam.
        //            }
        //        }
        //    }
        //}


    }
}
